C     Copyright (C) 2004 B. Roukema et al. <shape-univ at astro.uni.torun.pl>
C     
C     This program is free software; you can redistribute it and/or modify
C     it under the terms of the GNU General Public License as published by
C     the Free Software Foundation; either version 2 of the License, or
C     (at your option) any later version.
C     
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C     
C     You should have received a copy of the GNU General Public License
C     along with this program; if not, write to the Free Software
C     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C  
C     See also http://www.gnu.org/licenses/gpl.html

      subroutine pdodec  ! plot statistics for dodecahedral hypothesis
c     ==== plot "sigma" and "corr" parameters etc  ====
      parameter(pi=3.14159265359,pi_180=pi/180.0)
      
      parameter(maxflnm=3)
      character*256   flnm(maxflnm)
      character*3     ch3
      character*40    chxaxis

c      parameter(maxcurv=4)
      include 'npar.dec'
      real*4    q(maxcurv),cc(maxcurv)
      real*4    rSLS            ! distance to SLS in h^-1 Mpc
      real*4    drSLS           ! thickness of SLS in h^-1 Mpc

c     ---- difference statistics ----
c      parameter(mxsig=200)
c      parameter(mxsig=1000)

      parameter(mxsig=mxpar)
      real*4    sigma(mxsig,maxcurv)
      real*4    dmean(mxsig,maxcurv)
      real*4    sfreq(mxsig,maxcurv)
      real*4    corr(mxsig,maxcurv),cwght(mxsig,maxcurv)
      real*4    cdopp(mxsig,maxcurv)
      real*4    smooth(mxsig,maxcurv) ! just for playing 22/06/99

      real*4    glpar(mxsig) ! g long
      real*4    gbpar(mxsig) ! g lat
      real*4    thpar(mxsig) ! theta of dodecahedron rotation
      real*4    angpar(mxsig) ! ang radius of circle

c     ---- plot mode instead of scatter plot ---
      logical*4  plmode ! plot mode
c      parameter(mxang=6000)
      parameter(mxang=600)
      real*4    cbmplot(mxang),angplot(mxang)

      parameter(maxpair=20000)
c      parameter(maxpair=20)

      parameter(mxdlist=1,idlist=1)      
      real*4    dlist(maxpair,mxdlist,maxcurv)
      integer*4  npair(mxsig,maxcurv)

c     --- single sig value --- (circleT2.f initial version)
      real*4    sigma_ci(maxcurv,mxsig)
      real*4    dmean_ci(maxcurv,mxsig)
      real*4    sfreq_ci(maxcurv,mxsig)
      real*4    corr_ci(maxcurv,mxsig),cwght_ci(maxcurv,mxsig)
      real*4    cdopp_ci(maxcurv,mxsig)

c     ---- for plotting ----
      parameter(mxplot= mxsig)
      real*4    sigmap(mxsig)
      real*4    dmeanp(mxsig)
      real*4    corrp(mxsig)
      real*4    cdoppp(mxsig)

      real*4    glparp(mxsig)    ! g long
      real*4    gbparp(mxsig) ! g lat
      real*4    thparp(mxsig) ! theta of dodecahedron rotation
      real*4    angpp(mxsig) ! ang radius of circle

      real*4    corrq(mxsig)
      real*4    glparq(mxsig)    ! g long
      real*4    gbparq(mxsig) ! g lat


c      parameter(mxbin=100)
c      real*4    angbin(mxbin),angfreq(mxbin)
      parameter(mxangpair=mxang*mxang)
      real*4    ang12(mxangpair)

      logical*4 test, smoolog
c      character*2  ch2
      character*1  ch1
c      character*3  ch3


      parameter(nface=12)
c     -- centre of each face --
      real*4  xdod(nface),ydod(nface),zdod(nface)
      real*4  gldod(nface),gbdod(nface)

c     -- orthogonal unit vectors to generate circle
      real*4  xdodp(nface,2),ydodp(nface,2),zdodp(nface,2) ! perpendiculars

      real*4    erffun
      external  erffun

c     ---- plotting of KS prob2 added for counter.tex -- added 24/08/99 --- 

      logical*4 doxarbit ! arbitrary x-axis
      logical*4 doxgl,doxgb ! do gl or gb as x-axis
      logical*4 doxth         ! show as fn of thpar in x-axis
      logical*4 doxang ! show as fn of angle in x-axis
      logical*4 doxoffset ! small random x-offset to separate points
      logical*4 doline ! pgline or pgpoint?
      logical*4 doangf         ! filter by angle
      real*4    angf1,angf2
      real*4    xarbit(mxpar)

      logical*4 doacmax ! hardwire acmax
      logical*4 doasmax         ! hardwire asmax

      logical*4 doascii ! ascii output

      logical*4 domode ! do mode of 3 files? ! not yet implemented

      logical*4 do4plots ! do the standard 4 plots
      logical*4 doskydist ! plot sky distribution of selected points

      logical*4 docweight ! use cwght for corr because of g plane etc

c      logical*4       doerrupper
c      common /erruppcomm/ doerrupper,errupper ! shared with rdWMAP
      include 'errupp.dec'

      data flnm /'sigmaall.dat',' ',' '/
c      data flnm /
c     _     '../sigma_39z.dat',
c     _     '../sigma_39m.dat',
c     _     '../sigma_39p.dat'
c     _     /
c      data flnm /'sigmaall_res5d_w5d.dat'/

c      data nflnm /1/

      data tol /1e-4/

      test=.false. !.true. ! 
      smoolog=.false. !.true.            ! 

      doxarbit=.true. !.false. !
      doxgl = .false. !.true. !
      doxgb = .false. !.true.            !
      doxang = .true.            !.false.          !
      doxth = .false.           !.true.            !

      doxoffset = .true.        !.false.       !

      do4plots=  .true.!.false.!
      doskydist= .false. !.true. !
      nbin= 90
      bin1= 0.0
      bincut= 0.0! 30.0  ! don't count angles below bincut
      bin2= 180.0
      
      dodec1= 63.43             ! separation between adjacent faces in degrees
      dodec2= 116.57            ! separation between non-adjacent faces deg
      

      docweight= .false. !.true.           !
      aa= 11.0 ! alpha in degrees
      delth= 0.5 ! resdodec in degrees = angular resolution around circle
      var_t= 0.07*0.07 ! variance in temperatures mK^2 - rough estimate
      cwght0= 2.0*  ! factor of two in defn of cwght = tt1*tt1+tt2*tt2
     _     2.0*pi* aa /delth * var_t
      angp0= aa

      doline=.false. ! .true.!
      doangf= .false. !.true.!
      angf1= 37.0! 5.0! 30.0! 8.0 !                  !8.0
      angf2= angf1 +1.0 !38.0 !40.0 !14.0
c      angf1=27.0
c      angf2=37.0

      doacmax=.true.! .false. ! 
      acmax0 = 1.5
      doasmax=.true.            ! .false. ! 
      asmax0 = 80.0 /1.5

      doascii= .true.!.false. !
      corrmin=  1.4! 0.20 !99.9! 0.7! 0.37! 0.5 ! 99.9!
      sigmax=  -99.9! 15.0! 33.0

      domode=.false.            !.true.! 
      if(domode)then
         stop 'domode  not yet implemented'
         nflnm=3
      else
         nflnm=1
      endif

      plmode= .false. !.true.!
      if(plmode)nflnm=1

      dlin1= -1.5
      dlin2= 1.5
      dlog1= -1.9
      dlog2=0.3
      slin1= 0.0
      slin2= 0.15 !2.5
      clin1= -0.03
      clin2=0.03
      plin1=-0.015
      plin2=0.015

      isym=1
c     ...

c     -- which lambda_0 values to plot --
      icc1=1
      icc2=1
      iccstep=1

c     1,2 !24,25           ! 1,ncc,5      

      admax=-9e9
      asmax=-9e9
      acmax=-9e9
      apmax=-9e9

      print*,'nflnm=',nflnm
      do iflnm=nflnm,1,-1 !read 1st file last so that it's not overwritten
         print*,'iflnm=',iflnm

c     ---- read sigma's from file ----
         open(1,file=flnm(iflnm),access='sequential',
     _        form='unformatted',status='old')  ! 02.04.2003
         read(1)glong,galb,thetadeg,Rfund1,Rfund2,Rfund3,
     _        gl1_3,gb1_3,gl2_3,gb2_3, 
     _        xISW_0,ntd  ! added 24/08/99
         read(1)ncc,cc1,cc2,H_0,drSLS,ipar1,ipar2,
     _        mxpair

         nsig= ipar2-ipar1+1
         print*,'nsig=',nsig

         print*,' '
         print*,'iflnm,glong,galb,thetadeg=',
     _        iflnm,glong,galb,thetadeg
         print*,'Rfund1,Rfund2,Rfund3=',Rfund1,Rfund2,Rfund3,' : ',
     _        xISW_0,ntd


         write(6,'(a,f10.1,a,f10.1,a,f10.1,a,f10.1,a)'),
     _        'gl1_3,gb1_3,gl2_3,gb2_3=',
     _        gl1_3,' & ',gb1_3,' & ',gl2_3,' & ',gb2_3, ' & '
         print*,'ncc,cc1,cc2,H_0,drSLS,ipar1,ipar2,nsig,mxpair='
         print*,ncc,cc1,cc2,H_0,drSLS,ipar1,ipar2,nsig,mxpair


         read(1)((dmean(i,icc),i=1,nsig),icc=1,maxcurv)
         read(1)((sigma(i,icc),i=1,nsig),icc=1,maxcurv)
         read(1)((sfreq(i,icc),i=1,nsig),icc=1,maxcurv)
         read(1)(( corr(i,icc),i=1,nsig),icc=1,maxcurv)
         read(1)((cdopp(i,icc),i=1,nsig),icc=1,maxcurv)
         read(1)((cwght(i,icc),i=1,nsig),icc=1,maxcurv)
         read(1)((npair(i,icc),i=1,nsig),icc=1,maxcurv)

         read(1)(glpar(i),i=1,nsig)
         read(1)(gbpar(i),i=1,nsig)
         read(1)(thpar(i),i=1,nsig)
         read(1)(angpar(i),i=1,nsig)

         read(1)(((dlist(ip,i,icc),ip=1,mxpair),
     _        i=1,mxdlist),icc=1,ncc)
         close(1)

         if(domode.or.plmode)then
            print*,'will call initmodeang',nflnm,iflnm,nsig
            print*,'plotdodec: domode/plmode Not yet implemented!'
c            call initmodeang(nflnm,iflnm,nsig,corr,sigma,angpar)
         endif

         if(plmode)then
            print*,'plotdodec: domode/plmode Not yet implemented!'
c            call setmodeang( 
c     _           nangplot,cbmplot,angplot) 
            iang=1
c            tol=1e-4
            cbmmax= -99.9
            do while(iang.lt.nangplot.and.angplot(iang).lt.angf1)
               iang=iang+1
            enddo
            if(cbmplot(iang).gt.cbmmax)then
               cbmmax=cbmplot(iang)
               ibest= iang
            endif
            do while(iang.lt.nangplot.and.angplot(iang).lt.angf2)
               if(cbmplot(iang).gt.cbmmax)then
                  cbmmax=cbmplot(iang)
                  ibest= iang
               endif
               iang=iang+1
            enddo
            print*,'ibest,angplot(ibest)=',ibest,angplot(ibest)
            
         endif

c     ----

         icc=1
         icc0=1

         print*,'dmean(i,icc),icc=1,10=',(dmean(i,icc),i=1,10)
         print*,'sigma(i,icc)^2,icc=1,10=',(sigma(i,icc),i=1,10)
         print*,'sfreq(i,icc),icc=1,10=',(sfreq(i,icc),i=1,10)
         print*,'corr(i,icc),icc=1,10=',(corr(i,icc),i=1,10)
         print*,'cdopp(i,icc),icc=1,10=',(cdopp(i,icc),i=1,10)
c         endif

         glmin=9e9
         glmax=-9e9
         gbmin=9e9
         gbmax=-9e9
         angmin=9e9
         angmax=-9e9

         do icc=1,ncc
            do ipar=1,nsig
               dmean_ci(icc,ipar)=dmean(ipar,icc)
               if( sigma(ipar,icc) .gt.0.0)then
c     sigma_ci(icc,iflnm)= sqrt( sigma(ipar,icc ) )  !not the sd.!
                  xx= sigma(ipar,icc ) 
     _                 - dmean(ipar,icc)*dmean(ipar,icc) 
                  if(xx.gt.0.0)then
                     sigma_ci(icc,ipar)= sqrt(xx)
c     --- if errupper is just a constant, then don't use it ---
                     if(doerrupper)then
                        sigma_ci(icc,ipar)= 
     _                       sigma_ci(icc,ipar)*errupper
     _                       *1000.0 ! convert to microK
                     endif

                  else
                     sigma_ci(icc,ipar)= -0.99
                  endif
               else
                  sigma_ci(icc,ipar)= -0.99
               endif


               sfreq_ci(icc,ipar)=sfreq(ipar,icc)
               corr_ci(icc,ipar)=corr(ipar,icc)
               cdopp_ci(icc,ipar)=cdopp(ipar,icc)
               cwght_ci(icc,ipar)=cwght(ipar,icc)

               admax=max(admax,abs(dmean_ci(icc,ipar)))
               asmax=max(asmax,abs(sigma_ci(icc,ipar)))
               acmax=max(acmax,abs(corr_ci(icc,ipar)))
               apmax=max(apmax,abs(cdopp_ci(icc,ipar)))
               glmin=min(glmin, glpar(ipar))
               glmax=max(glmax, glpar(ipar))
               gbmin=min(gbmin, gbpar(ipar))
               gbmax=max(gbmax, gbpar(ipar))


               if(test)then
                  if(angpar(ipar).lt.angmin)
     _                 print*,'ipar,angmin,angpar=',
     _                 ipar,angmin,angpar(ipar)
               endif
               


               angmin=min(angmin, angpar(ipar))
               angmax=max(angmax, angpar(ipar))
            enddo
         enddo ! do icc=1,ncc
         if(test)print*,'ipar=',ipar
      enddo  !      do iflnm=1,nflnm

      print*,'admax,asmax,acmax,apmax=',admax,asmax,acmax,apmax
      print*,'glmin,glmax,gbmin,gbmax,angmin,angmax=',
     _     glmin,glmax,gbmin,gbmax,angmin,angmax
      print*,' '

      do icc=1,ncc
         do ipar=1,nsig
            sigma(ipar,icc)= sigma_ci(icc,ipar)
         enddo
      enddo





c     --- curv pars ---
      if(ncc.eq.1)then
         dcc=99.9
      else
         dcc=(cc2-cc1)/real(ncc-1)
      endif
      do icc=1,ncc
         cc(icc)=cc1+(real(icc-1))*dcc
         q(icc)= 0.5-1.5*cc(icc)
      enddo
      do icc=1,ncc
         print*,' '
         print*,'icc,cc(icc),dmean(1,icc),sigma(1,icc),',
     _        'sfreq(1,icc),corr(1,icc),cdopp(1,icc),cwght(1,icc)'
         print*,icc,cc(icc),dmean(1,icc),sigma(1,icc),
     _        sfreq(1,icc),corr(1,icc),cdopp(1,icc),cwght(1,icc)
      enddo


c     ==== filter for plots and outputs ====
      if(ncc.gt.1)print*,'WARNING: assuming ncc=1'
      icc=ncc

      ip=0
      do isig=1,nsig
         if( (.not.(doangf)).or.
     _        ( 
     _        (doangf.and.angf1.lt.angpar(isig)
     _        .and.angpar(isig).lt.angf2)
     _        )
     _        )then
            ip=ip+1

            sigmap(ip)=sigma(isig,icc)
            dmeanp(ip)=dmean(isig,icc)
            corrp(ip)=corr(isig,icc)
            cdoppp(ip)=cdopp(isig,icc)

            if(docweight)then
c     --- this is really just a normalisation by the number of pixels,
c     done using cwght since nthc is not stored for every calculation ---
               if(cwght(isig,icc).gt.tol)then
                  corrp(ip)= corr(isig,icc)
     _                 *(cwght(isig,icc)/cwght0) !
     _                 *(angp0/angpar(isig))
               endif
            endif

            
            glparp(ip)=glpar(isig)
            gbparp(ip)=gbpar(isig)
            thparp(ip)=thpar(isig)
            angpp(ip)=angpar(isig)

            if(domode)then
            print*,'plotdodec: domode/plmode Not yet implemented!'
c               call getmodeang( sigmap(ip),corrp(ip),angpp(ip),
c     _              sigout,corout)
               sigmap(ip)=sigout
               corrp(ip)=corout
               acmax0= 5.0
               doasmax=.true.   ! .false. ! 
               asmax0= 10.0
            endif
         endif
      enddo
      np=ip
      print*,'plotting: np=',np

      if(np.le.0)stop 'np too small'
      

c     ==== ascii output ====
      if(doascii)then
         do ip=1,np
            if(corrp(ip).gt.corrmin.or.sigmap(ip).lt.sigmax)then
               write(6,'(a,2f7.2,4f8.1)')
     _              'highcor: ',corrp(ip),sigmap(ip),
     _              glparp(ip),gbparp(ip),thparp(ip),angpp(ip)
               call gendodec(glparp(ip),gbparp(ip),thparp(ip),
     _              xdod,ydod,zdod, 
     _              xdodp,ydodp,zdodp)
               do idod=1,7
                  call xyz_rda(xdod(idod),ydod(idod),zdod(idod), 
     _                 rr,del,alph)
                  gldod(idod)= alph*15.0
                  gbdod(idod)= del
               enddo
               write(6,'(a,14f6.1)')
     _              'dod: ',(gldod(idod),gbdod(idod),idod=1,6)
            endif
         enddo
      endif



c     ==== plots ====
      fact=1.1
      if(doacmax)then
         acmax= acmax0
      endif
      if(doasmax)then
         asmax= asmax0
      endif

      if(do4plots)then
         do iplot=1,4
            x1=cc(1)
            x2=cc(ncc)
            if(iplot.eq.1)then
c               y1=dlin1
c               y2=dlin2
               y1=-admax *fact
               y2=admax *fact
            elseif(iplot.eq.2)then
c               y1=slin1
c               y2=slin2
c               y1=-asmax
               y1=0.0
               y2=asmax *1.5
               if(doangf)then
                  y1= 2.0
                  y2= 7.0
               endif
            elseif(iplot.eq.3)then
c               y1=clin1*2.0
c               y2=clin2*2.0
               y1= -acmax *fact
               y2=acmax *fact
               if(doangf)then
                  y1= 0.2
                  y2= 1.0
               endif
            elseif(iplot.eq.4)then
c               y1=plin1*2.0
c               y2=plin2*2.0
               y1=-apmax *fact
               y2=apmax *fact
            endif

c            if(.not.(dolong.or.doRGpc))then
c               y1=-0.1
c               y2=0.3
c            endif

            if(test)print*,'iplot,y1,y2=',iplot,y1,y2


c     write(ch2(1:2),'(i2)')iflnm
c     ch2(2:2)='A'
c     if(ch2(1:1).eq.' ')ch2(1:1)='_'

c     --- v0.1.33 -- shifted this earlier and replaced system( )
            if(iplot.eq.1)then
               ch1='d'
            elseif(iplot.eq.2)then
               ch1='s'
            elseif(iplot.eq.3)then
               ch1='c'
            elseif(iplot.eq.4)then
               ch1='p'
            endif


            if(2+2.eq.5)then !.or.(.not.(dolong).and.iplot.eq.1))then

               call pgbegin(0,'circ_cc_'//ch1//'.ps/vps',1,1)              
c               call pgbegin(0,'/vps',1,1)              
               call pgvsize(1.0,6.0,1.0,5.0)
               call pgslw(3)
               call pgscf(2)
               call pgsch(1.2)
               
               call pgwindow(x1,x2,y1,y2)
               call pgbox('bcnts',0.,0,'bcnts',0.,0)
c     endif

               if(iplot.eq.1)then
                  call pglabel('\\gl\\d0',
     _                 '<d>',' ')
               elseif(iplot.eq.2)then
                  call pglabel('\\gl\\d0',
     _                 '<\\gs\\u2\\d>\\u1/2',' ')
c     _              '<\\gs\\u2\\d(r\\dij\\u)>',' ')
c     call pgline(ncc,cc,sav)
               elseif(iplot.eq.3)then
                  call pglabel('\\gl\\d0','<S>',' ')
c     call pgline(ncc,cc,cav)
               elseif(iplot.eq.4)then
                  call pglabel('\\gl\\d0',
     _                 '<S\\dDopp\\u>',' ')
c     call pgline(ncc,cc,pav)
               endif

               do ipar=1,nsig
                  if(ipar.eq.1)call pgslw(5)
                  
                  if(iplot.eq.1)then
                     call pgline(ncc,cc,dmean_ci(1,ipar))
                     if(ipar.eq.1)
     _                    call pgpoint(ncc,cc,dmean_ci(1,ipar),17)
                     if(ipar.eq.17)
     _                    call pgpoint(ncc,cc,dmean_ci(1,ipar),3)
                  elseif(iplot.eq.2)then
                     call pgline(ncc,cc,sigma_ci(1,ipar))
                     if(ipar.eq.1)
     _                    call pgpoint(ncc,cc,sigma_ci(1,ipar),17)
                     if(ipar.eq.17)
     _                    call pgpoint(ncc,cc,sigma_ci(1,ipar),3)
                  elseif(iplot.eq.3)then
                     call pgline(ncc,cc,corr_ci(1,ipar))
                     if(ipar.eq.1)
     _                    call pgpoint(ncc,cc,corr_ci(1,ipar),17)
                     if(ipar.eq.17)
     _                    call pgpoint(ncc,cc,corr_ci(1,ipar),3)
                  elseif(iplot.eq.4)then
                     call pgline(ncc,cc,cdopp_ci(1,ipar))
                     if(ipar.eq.1)
     _                    call pgpoint(ncc,cc,cdopp_ci(1,ipar),17)
                     if(ipar.eq.17)
     _                    call pgpoint(ncc,cc,cdopp_ci(1,ipar),3)
                  endif
                  if(ipar.eq.1)call pgslw(3)
               enddo

               call pgend


c               call system(
c     _           'mv pgplot.ps circ'//ch2//
c     _           '_'//ch1//'.ps')
c     _              'mv pgplot.ps circ_cc_'//ch1//'.ps')

c     print*,'Line following system call ... cc...'
            endif !



c     ---- function of longitude ----

            if(doxarbit)then
               do i=1,nsig
                  xarbit(i)=real(i)
               enddo
               x1=0.0
               x2=real(nsig)+1.0
               if(doxgl)then
                  do i=1,nsig
                     xarbit(i)= glparp(i)
                  enddo
                  print*,'glmin,glmax=',glmin,glmax
                  x1= 0.0
                  x2= 360.0
               elseif(doxgb)then
                  do i=1,nsig
                     xarbit(i)= gbparp(i)
                  enddo
                  print*,'gbmin,gbmax=',gbmin,gbmax
                  x1= gbmin - 1.0
                  x2= 91.0
               elseif(doxang)then
                  do i=1,nsig
                     xarbit(i)= angpp(i)! angpar(i)
                  enddo
                  x1= angmin-1.0
                  x2= angmax+1.0
                  if(doangf)then
                     x1= angf1 -1.0
                     x2= angf2 +1.0
                  endif
               elseif(doxth)then
                  do i=1,nsig
                     xarbit(i)= thparp(i)
                  enddo
                  x1= -3.0
                  x2= 75.0
               endif
               if(doxoffset)then
                  do i=1,nsig
c                     xarbit(i)=xarbit(i)+
c     _                    (randt()-0.5)* 0.03*(x2-x1)
                     xarbit(i)=xarbit(i)+
     _                    (rnd(17)-0.5)* 0.03*(x2-x1)  ! 17 is a dummy seed
                  enddo
               endif
            endif

            
            if(doxarbit.or.
     _           (.not.(doxarbit).and.iplot.eq.1))then
               call pgbegin(0,'circ_long_'//ch1//'.ps/vps',1,1) ! v0.1.33
c               call pgbegin(0,'/vps',1,1)              
               call pgvsize(1.0,6.0,1.0,5.0)
               call pgslw(3)
               call pgscf(2)
               call pgsch(1.2)
               
               call pgwindow(x1,x2,y1,y2)
               call pgbox('bcnts',0.,0,'bcnts',0.,0)
            endif

            if(doxarbit)then
               chxaxis='x (arbitrary)'
               if(doxgl)then
                  chxaxis='g longitude'
               elseif(doxgb)then
                  chxaxis='g latitude'
               elseif(doxang)then
                  chxaxis='angular radius of circle (degrees)'
               elseif(doxth)then
                  chxaxis='rotation defining dodec (degrees)'
               endif
            endif

            if(iplot.eq.1)then
               call pglabel(chxaxis, ! 'long',
     _              'd',' ')
            elseif(iplot.eq.2)then
               call pglabel(chxaxis, ! 'long',
c     _              '<\\gs\\u2\\d>',' ')
c     _              '\\gs',' ')
     _              '\\gs (\\gmK)',' ')
            elseif(iplot.eq.3)then
               call pglabel(chxaxis, ! 'long',
     _              'S',' ')
            elseif(iplot.eq.4)then
               call pglabel(chxaxis, ! 'long',
     _              'S\\dDopp\\u',' ')
            endif

            do icc=1,ncc
               if(icc.eq.1)then
                  call pgsls(1)
               elseif(icc.eq.2)then
                  call pgsls(2) ! dashed
               elseif(icc.eq.3)then
                  call pgsls(4) ! dotted
               endif

               if(doxarbit)then
                  if(iplot.eq.1)then
                     if(doline)then
                        call pgline(np,xarbit,dmeanp)
                     else
                        call pgpoint(np,xarbit,dmeanp,isym)
                     endif
                  elseif(iplot.eq.2)then
                     if(doline)then
                        call pgline(np,xarbit,sigmap)
                     else
                        call pgpoint(np,xarbit,sigmap,isym)
                     endif
                  elseif(iplot.eq.3)then
                     if(plmode)then
                        call pgline(nangplot,angplot,cbmplot)
                     elseif(.not.(smoolog))then
                        if(doline)then
                           call pgline(np,xarbit,corrp)
                        else
                           call pgpoint(np,xarbit,corrp,isym)
                        endif
                     else
                        if(doline)then
                           call pgline(nsig,xarbit,smooth(1,icc)) !! test only !!
                        else
                           call pgpoint(nsig,xarbit,smooth(1,icc),isym) !! test only !!
                        endif
                     endif
                  elseif(iplot.eq.4)then
                     if(doline)then
                        call pgline(np,xarbit,cdoppp)
                     else
                        call pgpoint(np,xarbit,cdoppp,isym)
                     endif
                  endif
               else
                  if(iplot.eq.1)then
                     call pgsls(1)
                  elseif(iplot.eq.2)then
                     call pgsls(2) ! dashed
                  elseif(iplot.eq.3)then
                     call pgsls(4) ! dotted
                  elseif(iplot.eq.4)then
                     call pgsls(3) ! dash-dotted ??
                  endif

c                  if(iplot.eq.1)then
c                     call pgline(nsig,xISW,dmean(1,icc))
c                  elseif(iplot.eq.2)then
c                     call pgline(nsig,xISW,sigma(1,icc))
c                  elseif(iplot.eq.3)then
c                     if(.not.(smoolog))then
c                        call pgline(nsig,xISW,corr(1,icc))
c                     else
c                        call pgline(nsig,xISW,smooth(1,icc)) !! test only !!
c                     endif
c                  elseif(iplot.eq.4)then
c                     call pgline(nsig,xISW,cdopp(1,icc))
c                  endif
               endif
               if(ipar.eq.1)call pgslw(3)
            enddo
            if(doxarbit.or.
     _           (.not.(doxarbit).and.iplot.eq.4))then
               call pgend
c               call system(
c     _              'mv pgplot.ps circ_long_'//ch1//'.ps')
            endif

         enddo                  !         do iplot=1,4
      endif !      if(do4plots)then

         
         if(doskydist)then
            iq=0
            do ip=1,np
               if(corrp(ip).gt.corrmin.or.sigmap(ip).lt.sigmax)then
                  iq=iq+1
                  corrq(iq)=corrp(ip)
c                  glparq(iq)= 360.0 - glparp(ip)
                  glparq(iq)= glparp(ip)  ! v0.1.33  nprotcart.f correction
            
                  gbparq(iq)= gbparp(ip)
               endif
            enddo
            nq=iq
            print*,'nq=',nq
            print*,' '

            if((nq*(nq+1)/2).gt.mxangpair)then
               print*,'Warning: nq = ',nq,' might be too big.'
            endif

            ierr1=0
               ii=0
               do iq1=1,nq-1
                  do iq2=iq1+1,nq
                     xx1=cos(gbparq(iq1)*pi_180)
     _                    *cos(glparq(iq1)*pi_180)
                     yy1=cos(gbparq(iq1)*pi_180)
     _                    *sin(glparq(iq1)*pi_180)
                     zz1=sin(gbparq(iq1)*pi_180)

                     xx2=cos(gbparq(iq2)*pi_180)
     _                    *cos(glparq(iq2)*pi_180)
                     yy2=cos(gbparq(iq2)*pi_180)
     _                    *sin(glparq(iq2)*pi_180)
                     zz2=sin(gbparq(iq2)*pi_180)

c                     ii=ii+1
                     aa= angle(xx1,yy1,zz1, xx2,yy2,zz2)
     _                    /pi_180 ! convert to degrees
                     if(aa.gt.bincut)then
                        ii=ii+1
                        if(ii.gt.mxangpair)then
                           ii=ii-1
                           ierr1=ierr1+1
                           if(ierr1.lt.5)then
                              print*,'WARNING: nq = ',nq,
     _                             ' is too big.'
                              print*,'will overwrite last value'
                           endif
                        endif
                        ang12(ii)= aa
                     endif
                  enddo
               enddo !               do iq1=1,nq-1
               nq2= ii
               y1=0.0
               y2=5.0 * (real(nq2)/real(nbin))
               
               call pgbegin(0,'angdist.ps/ps',1,1)
               call pgvsize(1.0,6.0,1.0,5.0)
               call pgslw(3)
               call pgscf(2)
               call pgsch(1.2)
               
               call pgwindow(bin1,bin2,y1,y2)
               call pgbox('bcnts',0.,0,'bcnts',0.,0)
               
               call pghist(nq2, ang12, bin1,bin2, nbin, 1)
               call pglabel('angle between correlated circles',
     _              'frequency',' ')

               call pgmove(dodec1,y1)
               call pgdraw(dodec1,y2)
               call pgmove(dodec2,y1)
               call pgdraw(dodec2,y2)

               call pgend
c            endif !            if((nq*(nq+1)/2.gt.mxangpair)then
               

            
            x1=0.0
            x2=360.0
            y1=0.0
            y2=90.0
            call pgbegin(0,'skyplot.ps/ps',1,1)              
            call pgvsize(1.0,8.0,1.0,5.0)
            call pgslw(3)
            call pgscf(2)
            call pgsch(1.2)
               
            call pgwindow(x1,x2,y1,y2)
            call pgbox('bcnts',0.,0,'bcnts',0.,0)
            
            call pgqch(qch)
            call pgsch(0.5)
            call pgpoint(nq,glparq,gbparq,17)
            call pgsch(qch)

            call pglabel('gal longitude','gal latitude',' ')
            call pgend
         endif

      end
